package com.zipcodewilmington.arrayutility;

import java.lang.reflect.Array;
import java.util.ArrayList;

/**
 * Created by leon on 3/6/18.
 */
public class ArrayUtility <T>{
    private T[] inputArray;

    public ArrayUtility(T[] inputArray){
        this.inputArray = inputArray;
    }

    public Integer countDuplicatesInMerge(T[] arrayToMerge, T valueToEvaluate) {
        ArrayUtility arrayUtil = new ArrayUtility<>(merge(arrayToMerge));
        Integer count = arrayUtil.getNumberOfOccurrences(valueToEvaluate);

        return count;
    }

    public  T getMostCommonFromMerge(T[] arrayToMerge) {
        ArrayUtility arrayUtil = new ArrayUtility<>(merge(arrayToMerge));
        int max = 0;
        T mostCommon = null;
        for (Object element : arrayUtil.inputArray){
            if (getNumberOfOccurrences((T)element) > max){
                max = getNumberOfOccurrences((T)element);
                mostCommon = (T)element;
            }

        }
        return mostCommon;
    }

    public Integer getNumberOfOccurrences(T valueToEvaluate) {
        Integer counter = 0;
        for (int i = 0; i < inputArray.length; i ++) {
            if (inputArray[i].equals(valueToEvaluate)) {
                counter++;
            }
        }
        return counter;
    }


    public T[] removeValue(T valueToRemove) {
        ArrayList<T> newArray = new ArrayList<>();
        for (int i = 0; i < inputArray.length; i++){
            if (!inputArray[i].equals(valueToRemove)){
                newArray.add(inputArray[i]);

            }
        }
        int newlength = newArray.size();
        inputArray = (T[]) Array.newInstance(inputArray.getClass().getComponentType(), newlength);
        return newArray.toArray(inputArray);

    }

    public Object[] merge(T[] array2){
        int count = 0;
        Object[] mergedArray = new Object[inputArray.length + array2.length];
        for (T element : inputArray){
            mergedArray[count] = element;
            count++;
        }

        for (T element : array2){
            mergedArray[count] = element;
            count++;
        }

        return mergedArray;
    }


}
